<template>
  <v-container fluid>
    <v-row class="mt-5 mb-6" style="position: relative;" justify="center">
      <v-icon v-on="on" v-if="isAdmin" @click="handleEntityRoute"
        style="position: absolute; left: 0; top: 50%; bottom: 50%; margin-left: 30px; font-size: 25px" small class="mr-1"
        position="">mdi-arrow-left</v-icon>
      <span style="position: relative">
        <h2 class="primary--text">
          <span v-if="secondName !== 'Nome entidade'"> {{ secondName }} / </span>
          <span class="secondary--text">
            {{ entityName }}
          </span>
        </h2>
        <div class="entitiesEdit">
          <v-tooltip v-if="userCanEditEntity" right color="primary" content-class="tooltip" nudge-right="22px"
            transition="slide-x-transition">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" @click="handleEditEntity" small class="mr-1">mdi-pencil</v-icon>
            </template>
            <span style="font-size:0.85rem;" class="text-center"><b>Editar</b> dados da entidade</span>
          </v-tooltip>
          <v-tooltip v-if="userCanManageEntity" right color="primary" content-class="tooltip" nudge-left="0px"
            transition="slide-x-transition">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small class="ml-1" @click="handleManage">mdi-cog</v-icon>
            </template>
            <span class="text-center"><b>Gerenciar</b> entidades filhas</span>
          </v-tooltip>
        </div>
      </span>
    </v-row>
    <v-row justify="center" class="navMenuEntity mb-5" >
        <management-menu v-if="isAdmin" />


      <!-- Botões apenas quando não tem todas funcionalidades -->
      <ButtonUsers v-if="!isAdmin && userCanReadUsers"
        :class="currentlyPath == 'Users' ? 'warning primary--text ml-4' : ' ml-4'" />
      <ButtonEntity v-if="!isAdmin && userCanReadEntities"
        :class="currentlyPath == 'Entities' ? 'warning primary--text ml-4' : ' ml-4'" />
      <!-- FIM Botões-->

      <support-resource-button
        v-if="hasMethod(['readSupportResource'
          , 'linkFromDrive', 'createFolder', 'linkFileDrive', 'linkFolderDrive', 'readMySupportResource', 'addFilesOnFolder'
          , 'addFileOnFolder','addFileOnFolderSupportResource', 'addFileOnFolder', 'createChildrenFolder', 'createLink', 'createChildrenLink', 'readFolderSupportResource', 'deleteSupportResource'])"
        :class="currentlyPath == 'SupportResource' ? 'warning primary--text ml-4 mb-3' : ' ml-4 mb-3'" />
      <!-- não checar esse privilégio 'addLocalFile
addLocalFile
addLocalFile' -->
      <button-collaborative-work v-if="hasMethod(['createCollaborativeWork', 'addDriveLink', 'addDriveFile', 'createTeam', 'createLinkCollaborativeWork'
        , 'readAll', 'downloadFile', 'readAllAvailable', 'updateInfos', 'updateAnswerInfos', 'updateExternalLink', 'removeFile', 'deleteAnswer', 'updateParticipants',
        'deleteParticipant', 'removeLink', 'deleteCollaborativeWork', 'readAnswerDetail', 'createAnswer', 'attachAnswerFile', 'updateAnswerData',
        'downloadFileAnswer', 'readCollaborativeWorkAvailableAnswers'])"
        :class="currentlyPath == 'CollaborativeWork' ? 'warning primary--text ml-4 mb-3' : ' ml-4 mb-3'" />

      <ButtonTests
        v-if="hasMethod(['testCreate', 'readAllTest', 'testReadPerId', 'testUpdate', 'testDelete', 'removeTest', 'monitorReadTest', 'monitorTestEnter'
          , 'studentGetClasses', 'studentTestEnter', 'studentGetTest', 'studentQuestionAnswer', 'teacherTestRead', 'teacherTestApplicationRead'])"
        :class="currentlyPath == 'ShowTests' ||
          currentlyPath == 'QuestionBank' ||
          currentlyPath == 'AreasQuestionBank'
          ? 'warning primary--text ml-4 mb-3'
          : ' ml-4 mb-3'
          " />

      <ButtonDirectEmail v-if="hasMethod(['createMessage', 'userReadPerPage', 'readUserSentMails', 'attachDocument', 'readUserAvailableMails'
        , 'updateUserReadMails', 'readAllUserMails'])"
        :class="currentlyPath == 'DirectMessage' ? 'warning primary--text ml-4' : ' ml-4'" />
    </v-row>
    <v-row style="font-size: 0.8rem;" class="mr-3" justify="end" no-gutters>
      <span>Você é um <b> {{ role }} </b> nessa entidade.</span>
    </v-row>
    <v-divider class="mt-3" />
    <transition mode="out-in">
      <router-view />
    </transition>
    <div style="text-align: center">
      <ButtonEHQ :class="currentlyPath == 'Main' ||
        currentlyPath == 'ManageAreas' ||
        currentlyPath == 'QuestionBank2' ||
        currentlyPath == 'TestsPage' ||
        currentlyPath == 'StudentTests'
        ? 'warning primary--text ml-4'
        : ' ml-4'
        " />
    </div>
    <v-dialog v-model="openDialogEdit" width="800px" @keydown.esc="resetDialogInfo" @click:outside="resetDialogInfo">
      <EditEntities :dialogEntitiesCreate="openDialogEdit" :showEdit="true" :titleDialogCreate="'Editar Entidade'"
        :itemToEdit="entityToEdit" @closeDialogCreate="closeEditEntity" @handleEdit="editEntitySettings" />
    </v-dialog>
    <v-dialog v-model="entitiesManageDialog.open" width="80%">
      <ManageEntities v-if="entitiesManageDialog.open" :entity-item="entitiesManageDialog.item"
        @close="closeEntitiesManageDialog" />
    </v-dialog>
  </v-container>
</template>

<script>
import Management from '../services/management'
import ButtonCollaborativeWork from '../components/collaborativeWork/buttonCollaborativeWork'
import ManagementMenu from '../components/management/ManagementMenu'
import SupportResourceButton from '../components/supportMaterial/SupportResourceButton'
import ButtonDirectEmail from '../components/directMessage/buttonDirectEmail'
import ButtonTests from '../components/ehqModule/button'
import ButtonEHQ from '../components/ehq/button'
import ButtonUsers from '../components/management/buttonUsers'
import ButtonEntity from '../components/management/buttonEntity'
import EditEntities from '../components/management/EntitiesCreate'
import ManageEntities from '../components/management/EntitiesManage'
import { mapGetters, mapState, mapMutations } from 'vuex'

export default {
  name: 'Entity',
  components: {
    ManagementMenu,
    SupportResourceButton,
    ButtonCollaborativeWork,
    ButtonDirectEmail,
    ButtonEHQ,
    ButtonTests,
    ButtonUsers,
    ButtonEntity,
    EditEntities,
    ManageEntities,
  },
  data: () => ({
    entityName: 'Codigo entidade',
    secondName: 'Nome entidade',
    currentlyPath: '',
    isAdmin: false,
    role: '',
    entitiesManageDialog: { open: false, item: {} },
    userCanReadUsers: false,
    userCanReadEntities: false,
    userCanEditEntity: false,
    userCanManageEntity: false,
    managementItems: [
      {
        title: 'Entidades',
        icon: 'mdi-account-group',
        to: '/management/entities',
      },
      {
        title: 'Papéis',
        icon: 'mdi-bookmark',
        to: '/management/roles',
      },
      {
        title: 'Usuários',
        icon: 'mdi-account-check',
        to: '/management/users',
      },
    ],
    openDialogEdit: false,
    entityToEdit: null,
  }),
  computed: {
    ...mapState('user', ['modulesMaxManagements', 'methods']),
    ...mapGetters('user', ['HAS_METHOD']),
    activeEntityUrl() {
      return '/entity/' + this.$route.params.entityName
    },
    checkUpdate() {
      return this.$store.state.user.updateHimselfRole
    },
  },
  watch: {
    async checkUpdate() {
      if (this.checkUpdate) {
        await this.checkEntities()
        await this.userCheckPrivileges('userCanEditEntity', 'updateEntity')
        await this.userCheckPrivileges('userCanManageEntity', 'addEntityOn')
        await this.userCheckPrivileges('userCanReadUsers', 'userRead')
        await this.userCheckPrivileges('userCanReadEntities', 'readEntityByName')
        this.$store.commit('user/UPDATE_HIMSELF_ROLE', false)
      }
    },
    entityName(last, actual) {
      this.showNameEntity()
    },
  },
  async beforeUpdate() {
    this.showNameEntity()
    this.path()
    this.checkEntities()
    await this.userCheckPrivileges('userCanEditEntity', 'updateEntity')
    await this.userCheckPrivileges('userCanManageEntity', 'addEntityOn')
    await this.userCheckPrivileges('userCanReadUsers', 'userRead')
    await this.userCheckPrivileges('userCanReadEntities', 'readEntityByName')
  },
  async created() {
    console.log("this.methods: ",this.methods);
    this.showNameEntity()
    this.path()
    this.checkEntities()
    await this.userCheckPrivileges('userCanEditEntity', 'updateEntity')
    await this.userCheckPrivileges('userCanManageEntity', 'addEntityOn')
    await this.userCheckPrivileges('userCanReadUsers', 'userRead')
    await this.userCheckPrivileges('userCanReadEntities', 'readEntityByName')
  },
  methods: {
    ...mapMutations('user', [
      'UPDATE_ROUTED_ENTITY',
      'UPDATE_MAPPED_ACTIONS',
      'UPDATE_SET_ACTIONS',
    ]),

    async handleEntityRoute(entityId, entityTitle) {
      // console.log('clicou p/ mudar entidade')
      try {
        let ret = await User.readEntityChild('5de991c539a92eec6b7b02b1')
        console.log(ret);
        await this.$setItem('entityChildren', ret.data)
        this.UPDATE_ENTITY_CHILDREN(ret.data)
      } catch (e) {
        console.log('e', e)
      }
      await this.UPDATE_ROUTED_ENTITY('5de991c539a92eec6b7b02b1')
      const routedEntity = await this.$getItem('routedEntity')
      if (routedEntity) {
        const userEntityActions = routedEntity.privileges.actions
        let setMethods = new Set()
        let map = new Map(
          userEntityActions.map((action) => {
            action.methods.forEach((method) => {
              setMethods.add(method)
            })
            return [action.name, action]
          })
        )
        this.UPDATE_MAPPED_ACTIONS(map)
        this.UPDATE_SET_ACTIONS(setMethods)
      }
      // this.$router.go()
      await this.$setItem('navEntityHistory', [])
      this.$router.push('/entity/UDESC/management/entities')
      // this.$router.push(`/entity/${'UDESC'}`).catch((err) => {})
    },
    resetDialogInfo() {
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', true)
    },
    // ...mapGetters('user', ['HAS_METHOD']),
    hasMethod(arr) {
      return arr.some(privilege => {
        return this.methods.has(privilege)
      })
    },
    // async hasMethod(arr) {
    //   // Obtenha o getter específico usando await
    //   const hasMethodGetter = console.log( await this.$store.getters['user/HAS_METHOD'].methos.has);

    //   // Agora você pode usá-lo de maneira assíncrona
    //   const hasMethods = console.log(await hasMethodGetter(arr))
    //   return hasMethods

    //   // Continue com a lógica dependente dos métodos
    //   // if (hasMethods) {
    //   //   console.log('Tem pelo menos um método!');
    //   // } else {
    //   //   console.log('Não tem nenhum método!');
    //   // }
    // },

    // async hasMethodGetter(arr){
    //   return arr.some(privilege => {
    //     return this.methods.has(privilege)
    //   })
    // },

    path() {
      let path = this.$route.name
      this.currentlyPath = path
    },
    async showNameEntity() {
      const routedEntity = await this.$getItem('routedEntity')
      const name = routedEntity.name
      this.entityName = name
      if (routedEntity.firstName) this.secondName = routedEntity.firstName
      else this.secondName = 'Nome entidade'
    },
    async checkEntities() {
      //checa se é admin com todas funcionalidades na entidade selecionada
      const routedEntity = await this.$getItem('routedEntity')
      let actions = 0
      this.role = routedEntity.privileges.label
      let id = routedEntity.id
      this.$store.commit('user/UPDATE_IDACTUALENTITY', id)

      routedEntity.privileges.actions.forEach((action) => {
        let check = this.modulesMaxManagements[action.name]
        if (check == '') {
          actions++
        }
      })

      if (actions == Object.keys(this.modulesMaxManagements).length) {
        console.log(
          `Possui todas funções de Management (${actions}/${Object.keys(this.modulesMaxManagements).length
          })`
        )
        this.isAdmin = true
      } else {
        console.log(
          `Não possui todas funções de Management (${actions}/${Object.keys(this.modulesMaxManagements).length
          })`
        )
        this.isAdmin = false
      }
    },

    async userCheckPrivileges(data, nameOfPrivilege) {
      //data = data do vue; nameOfPrivilege = nome do privilegio
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == nameOfPrivilege) {
          check = true
          return
        }
      })
      this[`${data}`] = check
    },
    //entity Manage
    async handleManage() {
      const routedEntity = await this.$getItem('routedEntity')
      this.entitiesManageDialog = {
        open: true,
        item: routedEntity,
      }
    },

    closeEntitiesManageDialog() {
      this.entitiesManageDialog = {
        open: false,
        item: {},
      }
    },

    closeEditEntity() {
      this.openDialogEdit = false
      this.entityToEdit = {
        modules: [],
        parentsId: [],
        name: '',
        firstName: '',
        visible: true,
        initialDate: '',
        endDate: '',
      }
    },

    //usando componente entitiesCreate
    async handleEditEntity() {
      const routedEntity = await this.$getItem('routedEntity')
      const name = routedEntity.name
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntityByName(entityId, actionId, name)
        if (ret.success) {
          let resultadoBusca = ret.data // retorna array
          resultadoBusca.forEach((item) => {
            if (item.id == entityId) {
              this.entityToEdit = item
              return
            }
          })
          if (this.entityToEdit) {
            this.openDialogEdit = true
          }
          this.$store.commit('user/UPDATE_LOADING', false)
        }
      } catch (e) {
        console.log('erro')
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async editEntitySettings(item) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      try {
        console.log("entoty");
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.updateEntity(entityId, actionId, item.id, item)
        if (ret.success) {
          let refreshRoutedEntity = routedEntity
          Object.assign(refreshRoutedEntity, { name: item.name })
          await this.$setItem('routedEntity', refreshRoutedEntity)
          this.entityName = item.name
          this.$store.commit('user/UPDATE_LOADING', false)
          this.openDialogEdit = false
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Dados da entidade <b>modificado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
          if (!ret.success) {
            this.$store.commit('user/UPDATE_LOADING', false)
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Não foi possível <b>editar</b> os dados da entidade!',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
          //ativa true no vuex, para conseguir alterar o nome da entidade no menu
          this.refreshRootEntities()
          this.$store.commit('user/UPDATE_REFRESH_NAME_ENTITIES', true)
        }
      } catch (e) {
        console.log('catch create role', e)
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async refreshRootEntities() {
      //altera o rootEntities no localstorage e no vuex(usa quando clica para mudar de entidade no menulateral)

      const routedEntity = await this.$getItem('routedEntity')
      const id = routedEntity.id
      const rootEntities = await this.$getItem('rootEntities')

      rootEntities.forEach((entity) => {
        if (entity.id == id) {
          Object.assign(entity, routedEntity)
          return
        }
      })
      this.$store.commit('user/UPDATE_ROOT_ENTITIES', rootEntities)
      await this.$setItem('rootEntities', rootEntities)
    },
  },
}
</script>
<style>
.navMenuEntity>.v-btn:hover {
  background: #e8e8e8;
  border: thin solid #e8e8e8;
}

.entitiesEdit {
  position: absolute;
  top: 6px;
  right: -53px;
}

.entitiesEdit>.v-icon:hover {
  color: #ffc107;
}

.tooltip {
  padding: 2px 8px;
}

/* transition v-router */
.v-enter,
.v-leave-to {
  opacity: 0;
}

.v-enter {
  transform: translate3d(0, -10px, 0);
}

.v-leave-to {
  transform: translate3d(0, 10px, 0);
}

.v-enter-active,
.v-leave-active {
  transition: all 0.3s;
}
</style>
